﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;

namespace howto_make_transparent_png
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The image.
        private Bitmap Bm = null;

        // Offset for displaying the image.
        private const int Offset = 10;

        // Open a file.
        private void mnuFileOpen_Click(object sender, EventArgs e)
        {
            if (ofdFile.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    Bm = new Bitmap(ofdFile.FileName);
                    picImage.ClientSize = new Size(
                        Bm.Width + 2 * Offset,
                        Bm.Height + 2 * Offset);
                    picImage.Visible = true;
                    picImage.Refresh();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        // Save the file.
        private void mnuFileSave_Click(object sender, EventArgs e)
        {
            if (sfdFile.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    Bm.Save(sfdFile.FileName, ImageFormat.Png);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        // Set the transparent pixel.
        private void picImage_MouseClick(object sender, MouseEventArgs e)
        {
            // Get the color clicked.
            Color color = Bm.GetPixel(e.X - Offset, e.Y - Offset);

            // Make that color transparent.
            Bm.MakeTransparent(color);

            // Show the result.
            picImage.Refresh();
        }

        // Draw the picture.
        private void picImage_Paint(object sender, PaintEventArgs e)
        {
            if (Bm == null) return;
            e.Graphics.DrawImage(Bm, Offset, Offset);
        }
    }
}
